' ClockClock24 By K. Moore 10/12/23
' Two touch points are
' Top Left     = Brightness up
' Bottom Left  = Brightness down
' Middle screen= Move on to next clock

' turn off default typing and force explicit typing
Option EXPLICIT
Option DEFAULT NONE
' turn off blinking LED while running
'SetPin GP25, DOUT
' Screen = 480*320
Const width = 480
Const height = 320
' colours used
Const c.face = RGB(black)'RGB(72, 72, 136)
Const c.outline = RGB(midgreen)
Const c.hand = RGB(white)
Const c.bg = RGB(black)
Const c.date = RGB(100,200,255)
Colour c.hand, c.bg ' Set the default colours
Const c.dispt = 3000   ' iterations at 'update' rate
Const udanm = 100 '40'80'0 ' animate at approx 5Hz, including calculation time.
Const udidl = 180 ' idle at approx 5Hz, including calculation time.
Const uk=1   ' UK of US date format, set to 0 for US.

Dim Integer ctrx(7)=(30,90,150,210,270,330,390,450)
Dim Integer ctry(2)=(110,170,230), r=30
Dim Integer dig(3),  min, lmin=60, nu, k, j, tim, hand, row, col, col1, ck
Dim Integer hl(1)=((r*0.94), (r*0.85))
' for rectangular hands
Dim Integer hsx(191), hsy(191), hxl0(191), hyl0(191)
Dim Integer htick(47), htickl(47), hands, hands1, hour, lasthour=24, lr, BSTdone
Dim Integer bright, brup, off, udt, udh, hc, animate, animatetype, handrates=1, aninc, fine=180
Dim Float   hpos(47), hinc(47), aclk
Const  sx=6, wi=10,  fo=-2, psx=0.6, dayb=95, eveb=75, nightb=5

' for rectangular hands
Dim Integer n(47)=(4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4)
Dim Integer mdig(5,9)=(15,45,45,15,45,45,23,23,23,15,45,45,0,0,0,15,45,30,0,0,0,15,30,45,15,0,23,15,45,45,0,0,0,30,15,45,0,45,0,30,30,30,0,23,23,15,45,45,15,45,45,15,45,45,15,0,0,15,45,45)
Dim Integer hdig(5,9)=(0,15,0,30,15,30,23,23,23,20,15,45,0,15,45,30,30,30,0,0,0,30,45,30,15,45,23,15,15,45,15,45,0,30,30,30,15,15,45,30,15,45,0,23,23,30,15,45,0,0,0,30,30,30,0,45,0,30,15,30)
Dim mo$(11) = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"), dt$

' Experimenting!
Option lcd320 off
Play wav "b:/wav/cs16"

FRAMEBUFFER create  'f
FRAMEBUFFER write f

' set screen backlight to day value
VAR Restore
If bright=0 Then bright=dayb
Backlight bright

animate=0
udt=1
aclk=-60/fine

CLS
' draw clock outline and face.
  For row=0 To 2
    For col=0 To 7
      Circle ctrx(col), ctry(row), r,,,c.outline,c.face
    Next
  Next
'Timer =0
'  Do
  For tim=0 To c.dispt
    min=Val(Mid$(Time$,4,2))
' Check to see if Minute has changed, if so update the new hand positions and rates
    If udt Then
      fine=180
      If animate=2 Then
' select different hand rates and directions
        Select Case handrates
        Case 1
          handinc1
        Case 2
          handinc4
        Case 3
          handinc3
        Case 4
          handinc2
        Case Else
          handinc5
        End Select
      ElseIf animate=3 Then
' Force a time update
        lmin=61
      EndIf
      If min<>lmin Then
        lmin=min
        animate=0
        If Not(min Mod 6) Then
          animate=1
          Inc animatetype
          If animatetype>=6 Then
            animatetype=1
            Inc handrates
            If handrates>=6 Then
              handrates=1
            EndIf
          EndIf
        EndIf
' Display the date at midnight.
        hour=Val(Left$(Time$, 2))
        If hour<lasthour Then
          dt$=Day$(Date$)
          If uk Then
            dt$=dt$+" "+Left$(Date$, 2)+mo$(Val(Mid$(Date$, 4, 2))-1)
          Else
            dt$=dt$+" "+mo$(Val(Mid$(Date$, 4, 2))-1)+Left$(Date$, 2)
          EndIf
          Text 0, 42, dt$+" "+Right$(Date$,4)+"  ", "LB", 5, 1, c.date
        EndIf
        udt=0 : off=0
' Save away the previous hand positions
        Math add htick(),0,htickl() : Math add htick(),0,hpos()
        If animate=1 Then
' select a different hand start pattern
          Select Case animatetype
          Case 1
            initanimate1
          Case 2
            initanimate4
          Case 3
            initanimate3
          Case 4
            initanimate2
          Case Else
            initanimate5
          End Select
        Else
          handinctime
        EndIf
      EndIf
      Brightness ' if removing this sub, you'll need to set lasthour somewhere
' slow down looping when nothing happening
      If animate=1 Then Pause udidl
'      Timer =0
' we have new hand positions, so move hand towards their new positions
    Else
      displclocks
    EndIf
  Next
'  Loop
VAR Save bright, handrates, animatetype
Flash Run 1

Sub displclocks
Local Integer cx, cy
Local Float hp, rh

 Do While udt=0
  ck=0
  For col=0 To 7
   For hand=0 To 1
    For row=0 To 2
      hands1=row+hand*3+col*6
      cx=ctrx(col) : cy=ctry(row)
      Inc hpos(hands1),hinc(hands1)
      hp=hpos(hands1)
      rh=Rad((hp+wi)*sx)
      hsx(ck)= cx+Cos(rh)*fo
      hsy(ck)= cy+Sin(rh)*fo
      Inc ck
      rh=Rad((hp-wi)*sx)
      hsx(ck)= cx+Cos(rh)*fo
      hsy(ck)= cy+Sin(rh)*fo
      Inc ck
      rh=Rad((hp+psx)*sx)
      hsx(ck)= cx+Cos(rh)*hl(hand)
      hsy(ck)= cy+Sin(rh)*hl(hand)
      Inc ck
      rh=Rad((hp-psx)*sx)
      hsx(ck)= cx+Cos(rh)*hl(hand)
      hsy(ck)= cy+Sin(rh)*hl(hand)
      Inc ck
     Next
    Next
   Next
' Pause required to prevent screen artifacts
   Pause udanm
' Erase the old hands.
   Polygon n(),hxl0(),hyl0(),c.face,c.face
' Draw new hands.
   Polygon n(),hsx(),hsy(),,c.hand
' Background copy framebuffer to screen
   FRAMEBUFFER copy f,n,b
   Pause 60
' copy the new hands, so we can erase them next time.
   Math add hsx(),0,hxl0():Math add hsy(),0,hyl0()
' check for when we've finished moving hands
  Inc off
  If off=fine Then udt=1 : Inc animate':Print Timer
  Brightness ' if removing this sub, you'll need to set lasthour somewhere
' Print Timer:Timer =0
 Loop
End Sub

Sub handinctime
  dig(2)=min\10 : dig(3)=min Mod 10
  dig(0)=hour\10 : dig(1)=hour Mod 10
  hands=0
  For col=0 To 7
    For hand=0 To 1
      k=col\2
      j=Choice(col Mod 2, 3,0)
' Special case for digit '1' to improve loyout of digits.
      If (k=1 And dig(1)=1) Or (k=3 And Dig(3)=1) Then
        j=Choice(col=2 Or col=6, 3,0)
      EndIf
' reverse the hand directions for each column, just because :-)
      aclk=aclk* -1
      For row=0 To 2
' check for hour or minute hand positions
        htick(hands)=Choice(hand, hdig(row+j,dig(k)), mdig(row+j,dig(k)))
' calculate the difference between old and new hand positions
        hc=htick(hands)-htickl(hands)
        hinc(hands)=Choice(hc, hc/fine, aclk)
        Inc hands
      Next
    Next
  Next
End Sub

Sub initanimate1
  hands=0
  For col=0 To 7 Step 2
    For row=0 To 2
      htick(hands)=45
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=0
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
    For row=0 To 2
      htick(hands)=15
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=30
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
  Next
End Sub

Sub handinc1
  aclk=aclk* -1
  For col=0 To 47
    hinc(col)=aclk
  Next
  udt=0 : off=0 : fine=360
End Sub

Sub initanimate2
  hands=0
  For col=0 To 7
    For row=0 To 2
      htick(hands)=22-col*2
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=52-col*2
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
  Next
End Sub

Sub handinc2
  hands=0
  For col=0 To 7
    For row=0 To 2
      hinc(hands)=aclk/2
      hinc(hands+3)=-aclk
      Inc hands
    Next
    Inc hands,3
  Next
  udt=0 : off=0 : fine=360
End Sub

Sub initanimate3
  hands=0
  For col=0 To 7
    For row=0 To 2
      htick(hands)=22
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=22
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
  Next
End Sub

Sub handinc3
  hands=0
  For col=0 To 7
    For row=0 To 2
      hinc(hands)=aclk
      hinc(hands+3)=-aclk
      Inc hands
    Next
    Inc hands,3
  Next
  udt=0 : off=0 : fine=360
End Sub

Sub initanimate4
  hands=0
  For col=0 To 7 Step 2
    For row=0 To 2
      htick(hands)=30
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=0
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
    For row=0 To 2
      htick(hands)=45
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=15
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
  Next
End Sub

Sub handinc4
  hands=0
  For col=0 To 7 Step 2
    For row=0 To 2
      hinc(hands)=aclk
      hinc(hands+3)=aclk
      Inc hands
    Next
    Inc hands,3
    For row=0 To 2
      hinc(hands)=aclk/2
      hinc(hands+3)=aclk/2
      Inc hands
    Next
    Inc hands,3
  Next
  udt=0 : off=0 : fine=360
End Sub

Sub initanimate5
  hands=0
  For col=0 To 7
    For row=0 To 2
      htick(hands)=45
      hc=htick(hands)-htickl(hands)
      hinc(hands)=Choice(hc, hc/fine, aclk)
      htick(hands+3)=15
      hc=htick(hands+3)-htickl(hands+3)
      hinc(hands+3)=Choice(hc, hc/fine, aclk)
      Inc hands
    Next
    Inc hands,3
  Next
End Sub

Sub handinc5
  hands=0
  For col=0 To 7
    For row=0 To 2
      hinc(hands)=aclk
      hinc(hands+3)=aclk/2
      Inc hands
    Next
    Inc hands,3
  Next
  udt=0 : off=0 : fine=360
End Sub


' If you remove this sub, you'll need to set lasthour somewhere, for the date to change
Sub Brightness
Local Integer month
' change brightness using screen touch points
  If Touch(DOWN) Then
    If Touch(X) <160 Then
      If Touch(Y) <160 Then
        bright=Choice(bright<10, bright+1, bright+5)
        If bright >100 Then bright=100
      ElseIf Touch(Y) >=160 Then
        bright=Choice(bright<10, bright-1, bright-5)
        If bright <0 Then bright = 0
      EndIf
    ElseIf Touch(X) >160 And Touch(X) <320 Then
      VAR Save bright, handrates, animatetype
      Flash Run 1
    EndIf
    Backlight bright
  EndIf
' Set screen brightness for dusk, month depentant
' only check this every 300 itterations so approx every minute.
  If brup > 3000 Then
    brup=0
    If hour <> lasthour Then
      lasthour=hour
      month= Val(Mid$(Date$, 4, 2))
' Jan, Nov or Dec
      If (month=1 Or month=11 Or month=12) And (hour=8 Or hour=15) Then
        bright=eveb
        If hour=8 Then bright=dayb
' May, June, July
      ElseIf (month=5 Or month=6 Or month=7) And (hour=5 Or hour=20) Then
        bright=eveb
        If hour=5 Then bright=dayb
' Feb, Oct
      ElseIf (month=2 Or month=10) And (hour=7 Or hour=16) Then
        bright=eveb
        If hour=7 Then bright=dayb
' March, Sept
      ElseIf (month=3 Or month=9) And (hour=6 Or hour=18) Then
        bright=eveb
        If hour=6 Then bright=dayb
' April, Aug
      ElseIf (month=4 Or month=8) And (hour=5 Or hour=19) Then
        bright=eveb
        If hour=5 Then bright=dayb
' Any other time of day
' Set to very dim over night.
      ElseIf hour=23 Then
        bright=nightb
      EndIf
' Update actual screen brightness
      Backlight bright
    EndIf
  EndIf
  Inc brup
End Sub
